#! /bin/gawk -f

BEGIN {
  ("basename " file) | getline filename
  close("basename " file)
  sub(".org$", ".html", filename)
  link = "/posts/" filename
}

/^<h1>.*<\/h1>/ && !title {
  title = substr($0, 5, length($0) - 9)
}

/^#\+META: Description: / {
  description = substr($0, length("#+META: Description: ") + 1)
}

/^<time>.*<\/time>/ && !time {
  time = $0
}

END {
  print("<h3><a href=\"" link "\">" title "</a></h3>")
  print("<p>" description "</p>")
  print time
}
