#! /bin/bash

# Example call:
# ./export-new.sh ../src/news-raw ../build/news-exported "-v header=h1"
# See export.awk for possible export args

echo "Checking $1 for new entries"

tmpfile=$(mktemp)
srcdir=$1
targetdir=$2
exportargs=$3

mkdir -p $targetdir

for file in $(ls $srcdir)
do
    if ! [[ $file =~ [0-9]{4}-?[0-9]{2}-?[0-9]{2}(-[a-zA-Z]{3}-[0-9]{2}-[0-9]{2})?-.* ]] ; then
        ./export.awk $exportargs "$1/$file" 3>$tmpfile 1>"$targetdir/$file"
        mv "$targetdir/$file" "$targetdir/$(cat $tmpfile)-$file"
        mv "$srcdir/$file" "$srcdir/$(cat $tmpfile)-$file"
        echo "$srcdir/$file -> $targetdir/$(cat $tmpfile)-$file"
    fi
done

rm $tmpfile
