#! /bin/gawk -f

# Example call:
# ./fill-template.awk ../src/templates/foo.html

# Available directives:
# #+INSERT <path> [<count> <offset> LI EXEC: <command>]
# #+SH <command>

BEGIN {
  # Get the path to the template directory, necessary because paths used
  #   in include directives are relative to the template.
  # Looks like FILENAME is not available in BEGIN blocks, so use ARGC, ARGV.
  TemplateFile = ARGV[ARGC - 1]
  ("dirname " TemplateFile) | getline TemplateFileDir
  close("dirname " TemplateFile)
}

{
  if ($1 == "#+INSERT") {
    path = $2
    count = $3 ? " | head -n " $3 : ""
    offset = $4 ? " | tail -n +" $4 : ""
    li = ($5 == "LI" ? "| sed -e '1i\\<li>' -e '\\$a</li>'" : "");
    execBegin = index($0, "EXEC:")
    exec = execBegin ? " | " substr($0, execBegin + 5) : ""
    relPath = TemplateFileDir "/" path
    tmp = "find " relPath " | sort -r " offset count " | xargs -I {} sh -c \"cat {}" exec li "\""
    while ((tmp | getline) > 0) {
      print
    }
    close(tmp)
  } else if ($1 == "#+SH") {
    command = substr($0, index($0, $2))
    while ((command | getline) > 0) {
      print
    }
    close(command)
  } else {
    print
  }
}
